{
            Explod.Pas
            By: Chuck Johnson
            CIS: 73730,623

     This is a unit to draw exploding/imploding boxes. It is obviously
     rough and I'm sure that my use of OOP leaves alot to be desired.
     I might have overlooked some blatant needs for optimization (although
     some intentional). I'm used to working as a pair(NO! NOT WITH MYSELF!)*
     Please look at it and feel free to leave brutal comments to me at
     the above address. Also if you have seen other exploding box routines
     in any language, please say so.

                                 * A little poem came to mind:

                                 Roses are red,
                                 Violets are blue
                                 I'm a schizophrenic
                                 AND SO AM I!!

                                 }

Unit Explod;

Interface

 Const
   Explode = True;
   Implode = False;
   Horizontal = True;
   Vertical = False;

 Type
   ExplBox = Object
             Color,                      {Color is for later Implementation}
             CenterX,
             CenterY,
             Length,
             Width,
             CurLength,
             CurWidth : Byte;
             Procedure Init(X, Y, Colour, TLength, TWidth : Byte);
             Procedure ChangeColor(Colour : Byte);
             Procedure Show;
             Procedure Hide;
             Procedure DoBox(Direction : Boolean);
            End;

 Procedure DrawLine(X1, Y1, X2, Y2 : Byte; Direction : Boolean; Ch : Char);

 Procedure Fast(Col, Row : integer; Message:String);


Implementation

 Procedure Delay(N : Word);     {Just an empty Loop to cut down on}
                                {Overhead, and to make compat. With CRT unit}
  Var
   Loop : Word;

  Begin
   For Loop := 0 To N Do
       Begin
    End;
  End;

 Procedure Fast(Col, Row : integer; Message:String);

  Var
   Offs : integer;              {Output Directly To Screen Mem pretty 'Fast'}
   Point : Byte;

  Begin
   Offs := (Row - 1) * 80 + col - 1;
   Offs := Offs + Offs;
   For Point := 1 to ord(message[0]) do
    Mem[$B800 : Offs + Point + Point - 2] := Ord(message[point]);
  End;

 Procedure DrawLine(X1, Y1, X2, Y2 : Byte; Direction : Boolean; Ch : Char);

  Var                          {Draws Line From (X1,Y1) to (X2,Y2) Using Ch}
    Start,
    Stop,
    Loop : Byte;


  Begin
   If Direction = Horizontal
    Then
     Begin
      Start := X1;
      Stop := X2;
     End
    Else
     Begin
      Start := Y1;
      Stop := Y2;
     End;
   If Start < Stop
    Then
      Inc(Start)
    Else
      Dec(Start);
   While Start <> Stop Do
    Begin
     If Direction = Horizontal
      Then
        Fast(Start, Y1, Ch)
      Else
        Fast(X1, Start, Ch);
     If Start < Stop
      Then
       Inc(Start)
      Else
       Dec(Start);
    End;
  End;

 Procedure ExplBox.Init(X, Y, Colour, TLength, TWidth : Byte);

  Begin
   Color := Colour;
   CenterX := X;
   CenterY := Y;
   Length := TLength;
   Width := TWidth;
   CurLength := 0;
   CurWidth := 0;
  End;

 Procedure ExplBox.ChangeColor(Colour : Byte);

  Begin
   Color := Colour;
  End;

 Procedure ExplBox.Show;

  Begin
   If (CurLength <> 0) And (CurWidth <> 0)
    Then
     Begin
      Fast(CenterX - CurLength, CenterY - CurWidth, #218);
      DrawLine(CenterX - CurLength, CenterY - CurWidth,
               CenterX + CurLength, CenterY - CurWidth,
               Horizontal, Chr(196));
      Fast(CenterX + CurLength, CenterY - CurWidth, #191);
      DrawLine(CenterX + CurLength, CenterY - CurWidth,
               CenterX + CurLength, CenterY + CurWidth,
               Vertical, Chr(179));
      Fast(CenterX + CurLength, CenterY + CurWidth, #217);
      DrawLine(CenterX + CurLength, CenterY + CurWidth,
               CenterX - CurLength, CenterY + CurWidth,
               Horizontal, Chr(196));
      Fast(CenterX - CurLength, CenterY + CurWidth, #192);
      DrawLine(CenterX - CurLength, CenterY + CurWidth,
               CenterX - CurLength, CenterY - CurWidth,
               Vertical, Chr(179));
     End;
  End;

 Procedure ExplBox.Hide;

  Begin
   If (CurLength <> 0) And (CurWidth <> 0)
    Then
     Begin
      Fast(CenterX - CurLength, CenterY - CurWidth, ' ');
      DrawLine(CenterX - CurLength, CenterY - CurWidth,
               CenterX + CurLength, CenterY - CurWidth,
               Horizontal, ' ');
      Fast(CenterX + CurLength, CenterY - CurWidth, ' ');
      DrawLine(CenterX + CurLength, CenterY - CurWidth,
               CenterX + CurLength, CenterY + CurWidth,
               Vertical, ' ');
      Fast(CenterX + CurLength, CenterY + CurWidth, ' ');
      DrawLine(CenterX + CurLength, CenterY + CurWidth,
               CenterX - CurLength, CenterY + CurWidth,
               Horizontal, ' ');
      Fast(CenterX - CurLength, CenterY + CurWidth, ' ');
      DrawLine(CenterX - CurLength, CenterY - CurWidth,
               CenterX - CurLength, CenterY + CurWidth,
               Vertical, ' ');
     End;
  End;


 Procedure ExplBox.DoBox(Direction : Boolean);

  Begin
    If Direction = Implode
      Then
       Begin
        CurLength := Length;
        CurWidth := Width;
        Length := 0;
        Width := 0;
       End;
    Repeat
     Delay(100);
     Self.Hide;
     If Direction = Explode
       Then
        Begin
         If CurLength <> Length
           Then
             Inc(CurLength);
         If CurWidth <> Width
           Then
             Inc(CurWidth);
        End
       Else
        Begin
         If CurLength <> Length
           Then
             Dec(CurLength);
         If CurWidth <> Width
           Then
             Dec(CurWidth);
        End;
     Self.Show;
    Until (CurLength = Length) And (CurWidth = Width);
  End;

End.